#include <stdlib.h>
#include <stdio.h>
#include <sys/mtio.h>
#include <string.h>
#include "dds2tar.h"

static int cur_n = 0 ;
static int cur_blkno = -1 ;
static tar_record*b;

/*--------------------------------------------------------------------*/
static struct {
	char n[100]; /* name of the dir */
	int b,r;     /* block adress */
} dir_list[64];
static int dir_b = 0 ;

void dir_print(void){
	int i ;
	for ( i = 0 ; i < dir_b ; i++ ) {
		fprintf(stderr,"dir_list[%d]=%s\n",i,dir_list[i].n);
	}
}
/*--------------------------------------------------------------------*/

/* procedure to extract the files from the specified area (sb:sr-eb:er) */
int extract(int sb, int sr, int eb, int er){

	struct mtpos pos;
	struct mtop op;
	int i;
	int n;

	if ( verbose ) fprintf(stderr,"extracting %d %d %d %d \n",sb,sr,eb,er);
	if ( verbose ) dir_print();

	if ( sb != cur_blkno ) {
		cur_blkno = dds_getpos();
		if ( cur_blkno != sb ) {
			dds_seek(sb);
			cur_blkno = sb;
		}
		/* if cur_n == 0, we read a filemark */
		do {
			cur_n = read(device,b,tar_n);
			if ( verbose ) fprintf(stderr,"filemark found\n");
		} while ( cur_n == 0 ) ;
		if ( cur_n < 0 ) {
			perror("dds2tar");
			exit(1);
		}
	}
	i = sr ;
	if (( eb == 0 ) && ( er == 0 )) {
		write(1,b+i,512);
		return 0 ;
	}
	while ( cur_n > 0 ){
		int bs ;
		if (( cur_n & 0x1ff ) != 0 ) {
			fprintf(stderr,
			"tape record size is not a multiple of tar records\n"
			);
			close(device);
			exit(1);
		}
		bs = cur_n >> 9 ;
		if ( cur_blkno == eb ) bs=er ;
		while ( i < bs ) {
			write(1,b+i,512),i++;
		}
		/* if eb==-1 extract until eof */
		if ( eb >= 0 ) if ( cur_blkno >= eb ) return 0;
		cur_blkno = dds_getpos();
		if ( ( cur_blkno == eb ) && (er == 0) ) return 0 ;
		i = 0 ;
		cur_n = read(device,b,tar_n);
	}
	return 0 ;
}

/*--------------------------------------------------------------------*/

/* for each dir, you should call dir_add */

static void dir_add(char*n,int b,int r){
	int i ;
	for ( i = 0 ; i < dir_b ; i++ ) {
		if ( strstr(n,dir_list[i].n) != n ) {
			break;
		}
	}
	if ( i >= 60 ) {
		fprintf(stderr,"dir_list voll\n");
		exit(1);
	}
	strcpy(dir_list[i].n,n);
	dir_list[i].b = b ;
	dir_list[i].r = r ;
	dir_b=i+1;
}

/* if you wich to extract the pathname n, this function extracts
   all directories, wich are not extracted yet. These are the
  directories inside the stack, wich are prefix of the pathname. */

static void dir_extract(char*n){
	int i;
	for ( i = 0 ; i < dir_b ; i++ ) {
		if ( strstr(n,dir_list[i].n) == n ){
			/* only extract, if it's a real prefix */
			if ( strcmp(n,dir_list[i].n) )
			extract(dir_list[i].b,dir_list[i].r,0,0);
		}
	}
	dir_b = 0 ;
}
/*--------------------------------------------------------------------*/

/* searching through the table for files to extract */
int dds_cmp(void){
  char*buf,*name=NULL;
  int blkno,recno,size;
  int sb,sr,eb,er;
  int i,n;
  char**p;
  int found;

  buf=(char*)malloc(1024);
  b=(tar_record*)malloc(N);
  if ( buf == NULL || b == NULL ) {close(device);perror("dds2tar");exit(1);}
  if ( tar_index_file == 0 ) fgets(buf,1024,index_fp);
  i = 0 ;
  found = 0 ;
  buf[0] = '+';
  if ( tar_index_file == 0 ) name = buf+27;
  while ( ( *buf != '-' ) && ( ! feof(index_fp) ) ) {
    fgets(buf,1024,index_fp);
    if ( tar_index_file == 0 ) {
      sscanf(buf+6,"%7d%3d:%9d",&blkno,&recno,&size);
    } else {
      char *p, *q ;
      while ( (!feof(index_fp)) && (buf[0] != 'r') &&
                                 (buf[1] != 'e') && (buf[2] != 'c')){
        /* try the next line */
        fgets(buf,1024,index_fp);
      }
      if ( feof(index_fp )) break ;
      recno = atoi(buf+4);
      blkno = recno / tar_bs ;
      recno -= blkno * tar_bs ;
      blkno += tar_fb ;
      if ( name == NULL ) { /* calculate only once */
        name = buf+65 ;
        if (( strlen(buf) < 66 ) || ( name[-1] != ' ' )) name = buf+16 ;
      }
    }
    if ( name[strlen(name)-1] == '\n' ) name[strlen(name)-1]='\0';
    if ( name[strlen(name)-1] == '/' ) dir_add(name,blkno,recno);
    p = cmp_list ;
    while ( *p != NULL ) {
      /* the following needs to done for strcmp */
      if (
        ((mode==PREFIX)&&(strstr(name,*p)==name))
        ||(!strcmp(name,*p))
        ||((mode==GREP)&&(strstr(name,*p)!=NULL))
      ){
        if ( found == 0 ) {
          found = 1 ;
          dir_extract(name);
          sb=blkno;
          sr=recno;
          if ( verbose ) fprintf(stderr,"found %s\n",name);
        }
        break ;
      }
      *p++ ;
    }
    if ( *p == NULL ) {
      if ( found == 1 ) {
        eb = blkno ;
        er = recno ;
        extract(sb,sr,eb,er);
        found = 0 ;
      }
    }
  }
  if ( found == 1 ) {
    eb = -1 ;
    er = -1 ;
    extract(sb,sr,eb,er);
    found = 0 ;
  }
  memset(b,0,N);write(1,b,512);
}

